// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rcss3d_agent_msgs:msg/ForceResistance.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/force_resistance.hpp"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__FORCE_RESISTANCE__STRUCT_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__FORCE_RESISTANCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rcss3d_agent_msgs__msg__ForceResistance __attribute__((deprecated))
#else
# define DEPRECATED__rcss3d_agent_msgs__msg__ForceResistance __declspec(deprecated)
#endif

namespace rcss3d_agent_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ForceResistance_
{
  using Type = ForceResistance_<ContainerAllocator>;

  explicit ForceResistance_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->px = 0.0f;
      this->py = 0.0f;
      this->pz = 0.0f;
      this->fx = 0.0f;
      this->fy = 0.0f;
      this->fz = 0.0f;
    }
  }

  explicit ForceResistance_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->px = 0.0f;
      this->py = 0.0f;
      this->pz = 0.0f;
      this->fx = 0.0f;
      this->fy = 0.0f;
      this->fz = 0.0f;
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _px_type =
    float;
  _px_type px;
  using _py_type =
    float;
  _py_type py;
  using _pz_type =
    float;
  _pz_type pz;
  using _fx_type =
    float;
  _fx_type fx;
  using _fy_type =
    float;
  _fy_type fy;
  using _fz_type =
    float;
  _fz_type fz;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__px(
    const float & _arg)
  {
    this->px = _arg;
    return *this;
  }
  Type & set__py(
    const float & _arg)
  {
    this->py = _arg;
    return *this;
  }
  Type & set__pz(
    const float & _arg)
  {
    this->pz = _arg;
    return *this;
  }
  Type & set__fx(
    const float & _arg)
  {
    this->fx = _arg;
    return *this;
  }
  Type & set__fy(
    const float & _arg)
  {
    this->fy = _arg;
    return *this;
  }
  Type & set__fz(
    const float & _arg)
  {
    this->fz = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator> *;
  using ConstRawPtr =
    const rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rcss3d_agent_msgs__msg__ForceResistance
    std::shared_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rcss3d_agent_msgs__msg__ForceResistance
    std::shared_ptr<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ForceResistance_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->px != other.px) {
      return false;
    }
    if (this->py != other.py) {
      return false;
    }
    if (this->pz != other.pz) {
      return false;
    }
    if (this->fx != other.fx) {
      return false;
    }
    if (this->fy != other.fy) {
      return false;
    }
    if (this->fz != other.fz) {
      return false;
    }
    return true;
  }
  bool operator!=(const ForceResistance_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ForceResistance_

// alias to use template instance with default allocator
using ForceResistance =
  rcss3d_agent_msgs::msg::ForceResistance_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rcss3d_agent_msgs

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__FORCE_RESISTANCE__STRUCT_HPP_
