// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/GyroRate.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/gyro_rate.h"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__GYRO_RATE__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__GYRO_RATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/GyroRate in the package rcss3d_agent_msgs.
/**
  * Information about the change in orientation of a body. The message contains the name of the body
  * to which the gyro perceptor belongs and three rotation angles. These rotation angles describe the
  * change rates in orientation of the body during the last cycle. In other words the current angular
  * velocities along the three axes of freedom of the corresponding body in degrees per second.
  * To keep track of the orientation of the body, the information to each gyro rate perceptor is sent
  * every cycle.
 */
typedef struct rcss3d_agent_msgs__msg__GyroRate
{
  /// The name of the body part the gyro rate perceptor is attached to
  rosidl_runtime_c__String name;
  /// The current angular velocities along the x axis in degrees per second
  float x;
  /// The current angular velocities along the y axis in degrees per second
  float y;
  /// The current angular velocities along the z axis in degrees per second
  float z;
} rcss3d_agent_msgs__msg__GyroRate;

// Struct for a sequence of rcss3d_agent_msgs__msg__GyroRate.
typedef struct rcss3d_agent_msgs__msg__GyroRate__Sequence
{
  rcss3d_agent_msgs__msg__GyroRate * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__GyroRate__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__GYRO_RATE__STRUCT_H_
