// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rcss3d_agent_msgs:msg/Beam.idl
// generated code does not contain a copyright notice

#include "rcss3d_agent_msgs/msg/detail/beam__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rcss3d_agent_msgs
const rosidl_type_hash_t *
rcss3d_agent_msgs__msg__Beam__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x48, 0xc3, 0x34, 0x8b, 0x3b, 0x7f, 0xe9, 0x46,
      0xd5, 0x07, 0x70, 0x0d, 0xfd, 0x3a, 0x33, 0x86,
      0x4d, 0x88, 0x22, 0x4f, 0x0a, 0xcc, 0x74, 0xb0,
      0x57, 0x64, 0xf2, 0x8f, 0xd2, 0x04, 0x0e, 0x7a,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char rcss3d_agent_msgs__msg__Beam__TYPE_NAME[] = "rcss3d_agent_msgs/msg/Beam";

// Define type names, field names, and default values
static char rcss3d_agent_msgs__msg__Beam__FIELD_NAME__x[] = "x";
static char rcss3d_agent_msgs__msg__Beam__FIELD_NAME__y[] = "y";
static char rcss3d_agent_msgs__msg__Beam__FIELD_NAME__rot[] = "rot";

static rosidl_runtime_c__type_description__Field rcss3d_agent_msgs__msg__Beam__FIELDS[] = {
  {
    {rcss3d_agent_msgs__msg__Beam__FIELD_NAME__x, 1, 1},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__Beam__FIELD_NAME__y, 1, 1},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__Beam__FIELD_NAME__rot, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rcss3d_agent_msgs__msg__Beam__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rcss3d_agent_msgs__msg__Beam__TYPE_NAME, 26, 26},
      {rcss3d_agent_msgs__msg__Beam__FIELDS, 3, 3},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# The beam effector allows a player to position itself on the field before the start of each half.\n"
  "# The x and y coordinates define the position on the field with respect to the field's coordinate\n"
  "# system, where (0,0) is the absolute center of the field. The rot specifies the facing angle of\n"
  "# the player. Zero points to positive x-axis, 90 to positive y-axis.\n"
  "\n"
  "float64 x  # metres\n"
  "float64 y  # metres\n"
  "float64 rot  # degrees";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rcss3d_agent_msgs__msg__Beam__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rcss3d_agent_msgs__msg__Beam__TYPE_NAME, 26, 26},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 426, 426},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rcss3d_agent_msgs__msg__Beam__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rcss3d_agent_msgs__msg__Beam__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
