// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rcss3d_agent_msgs:msg/GyroRate.idl
// generated code does not contain a copyright notice

#include "rcss3d_agent_msgs/msg/detail/gyro_rate__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rcss3d_agent_msgs
const rosidl_type_hash_t *
rcss3d_agent_msgs__msg__GyroRate__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x98, 0x85, 0x27, 0xa0, 0x92, 0xfd, 0x37, 0xbb,
      0xba, 0x8a, 0xd3, 0xab, 0xcf, 0x61, 0x60, 0xd8,
      0xc4, 0x97, 0x01, 0x78, 0xba, 0xe8, 0xad, 0x3a,
      0x7a, 0xd2, 0x79, 0xab, 0x22, 0xec, 0xfd, 0xd8,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char rcss3d_agent_msgs__msg__GyroRate__TYPE_NAME[] = "rcss3d_agent_msgs/msg/GyroRate";

// Define type names, field names, and default values
static char rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__name[] = "name";
static char rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__x[] = "x";
static char rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__y[] = "y";
static char rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__z[] = "z";

static rosidl_runtime_c__type_description__Field rcss3d_agent_msgs__msg__GyroRate__FIELDS[] = {
  {
    {rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__name, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__x, 1, 1},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__y, 1, 1},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__GyroRate__FIELD_NAME__z, 1, 1},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rcss3d_agent_msgs__msg__GyroRate__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rcss3d_agent_msgs__msg__GyroRate__TYPE_NAME, 30, 30},
      {rcss3d_agent_msgs__msg__GyroRate__FIELDS, 4, 4},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Information about the change in orientation of a body. The message contains the name of the body\n"
  "# to which the gyro perceptor belongs and three rotation angles. These rotation angles describe the\n"
  "# change rates in orientation of the body during the last cycle. In other words the current angular\n"
  "# velocities along the three axes of freedom of the corresponding body in degrees per second.\n"
  "# To keep track of the orientation of the body, the information to each gyro rate perceptor is sent\n"
  "# every cycle.\n"
  "\n"
  "string name  # The name of the body part the gyro rate perceptor is attached to\n"
  "float32 x  # The current angular velocities along the x axis in degrees per second\n"
  "float32 y  # The current angular velocities along the y axis in degrees per second\n"
  "float32 z  # The current angular velocities along the z axis in degrees per second";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rcss3d_agent_msgs__msg__GyroRate__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rcss3d_agent_msgs__msg__GyroRate__TYPE_NAME, 30, 30},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 837, 837},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rcss3d_agent_msgs__msg__GyroRate__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rcss3d_agent_msgs__msg__GyroRate__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
