// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rcss3d_agent_msgs:msg/Spherical.idl
// generated code does not contain a copyright notice

#include "rcss3d_agent_msgs/msg/detail/spherical__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rcss3d_agent_msgs
const rosidl_type_hash_t *
rcss3d_agent_msgs__msg__Spherical__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x25, 0x53, 0xa1, 0xa1, 0x1f, 0xa9, 0x86, 0x65,
      0xc3, 0x15, 0xc6, 0x71, 0xc2, 0x92, 0xcd, 0x5a,
      0x9f, 0xd5, 0x76, 0x0c, 0xae, 0x7e, 0xc6, 0x1a,
      0x6d, 0x08, 0x78, 0xfd, 0xdc, 0xe2, 0xdb, 0x23,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char rcss3d_agent_msgs__msg__Spherical__TYPE_NAME[] = "rcss3d_agent_msgs/msg/Spherical";

// Define type names, field names, and default values
static char rcss3d_agent_msgs__msg__Spherical__FIELD_NAME__r[] = "r";
static char rcss3d_agent_msgs__msg__Spherical__FIELD_NAME__phi[] = "phi";
static char rcss3d_agent_msgs__msg__Spherical__FIELD_NAME__theta[] = "theta";

static rosidl_runtime_c__type_description__Field rcss3d_agent_msgs__msg__Spherical__FIELDS[] = {
  {
    {rcss3d_agent_msgs__msg__Spherical__FIELD_NAME__r, 1, 1},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__Spherical__FIELD_NAME__phi, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__Spherical__FIELD_NAME__theta, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rcss3d_agent_msgs__msg__Spherical__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rcss3d_agent_msgs__msg__Spherical__TYPE_NAME, 31, 31},
      {rcss3d_agent_msgs__msg__Spherical__FIELDS, 3, 3},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Spherical msg used for soccer vision perceptors. All distances and angles are given\n"
  "# relative to the position and orientation of the camera.\n"
  "#\n"
  "# Details: https://gitlab.com/robocup-sim/SimSpark/-/wikis/Perceptors#vision-perceptors\n"
  "#\n"
  "# Angles are stored in degrees.\n"
  "\n"
  "# The distance to the seen object, in metres.\n"
  "float32 r\n"
  "\n"
  "# The horizontal angle (\\xcf\\x86) to the visible object relative to the view direction in degrees\n"
  "# and an accuracy of two digits. Positive angles are left of the vertical midline of the\n"
  "# agent's vision, negative angles right.\n"
  "float32 phi\n"
  "\n"
  "# The vertical angle (\\xce\\xb8) to the visible object relative to the view direction in degrees\n"
  "# and an accuracy of two digits. Positive angles mean the seen object is above the\n"
  "# horizontal midline of agent's vision, negative means below.\n"
  "float32 theta";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rcss3d_agent_msgs__msg__Spherical__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rcss3d_agent_msgs__msg__Spherical__TYPE_NAME, 31, 31},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 808, 808},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rcss3d_agent_msgs__msg__Spherical__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rcss3d_agent_msgs__msg__Spherical__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
